mob
{
	#ifdef SHOW_EXAMPLES
	icon_state = "mob";
	#endif

	#ifdef MOB_DEBUG
	#ifdef SEASONAL_LOOP
	verb
	{
		getSeason()
		{
			usr << "The season is: [season]";
			usr << "[season] has [seasons[season] - season_time] ticks left.";
			usr << "[round(((seasons[season] - season_time)/10)/60)]:[round(((seasons[season] - season_time)/10) % 60)]"
		}
		advanceSeason()
		{
			var i = 1;

			for(i, i<=seasons.len, i++)
			{
				if(seasons[i] == season)
				{
					break
				}
			}

			if(i == 4)
			{
				i = 1;
			}

			else
			{
				i++;
			}

			season = seasons[i];
			season_time = 0;
			#ifdef DEBUG_OUTPUT
			world.log<<"The season has changed! It is now [season].";
			#endif
			for(var/atom/a)
			{
				a.enviro_Season(season);
			}
		}
	}
	#endif
	#endif

	#ifdef SHOW_EXAMPLES

	Move()
	{
		..();
		for(var/mob/AI/m in view(5))
		{
			if(type != m.type)
			{
				m.Alert(src);
			}
		}
	}

	AI
	{
		var
		{
			enviro_active = TRUE; // While this is TRUE, the mob will participate in AI actions.
			step_time = 20; // This is how long the mob has until it takes another step.
			stationary = FALSE; // While this is TRUE, the mob will not take any unprovoked steps.
			alert_time = 100; // This is how long the animal will stay in it's alerted state.
			tmp
			{
				current_step_time = 0; // This is their current time.  When this reaches step_time, they step.
				alert = FALSE; // This is for animals.  If they hear a sound, they become alert.
				current_alert_time = 0; // This is how long they have been alerted.
				mob/alerted_to; // This is the mob that alerted them.  If they get too close, you run or attack.
				reaction_prob = 70; // This is the probability(percent) for them to run away.
				reaction_dist = 3; // This is how close they have to be before a reaction is made.
				attacking = FALSE; // If they are going to attack, they have their mind set.
			}
		}

		base_EventCycle()
		{
			if(enviro_active && client)
			{
				return FALSE;
			}

			current_step_time++;
			if(alert && alerted_to)
			{
				current_alert_time++;
				if(get_dist(src, alerted_to) <= reaction_dist)
				{
					if(!attacking)
					{
						var chance = prob(reaction_prob)
						if(chance)
						{
							step_away(src, alerted_to, reaction_dist)
						}

						else
						{
							attacking = TRUE
						}
					}

					if(attacking)
					{
						if(get_dist(src, alerted_to) <= 1)
						{
							if(alerted_to.client)
							{
								alert(alerted_to,"\A [src] attacked and killed you!","You died!");
								del alerted_to;
							}
						}
						if(get_dist(src, alerted_to) > 1 && alerted_to in view())
						{
							step_to(src, alerted_to);
						}

						else
						{
							alerted_to = null;
							alert = FALSE;
						}
					}
				}
				if(current_alert_time >= alert_time)
				{
					alert = FALSE;
					current_alert_time = 0
				}

				else
				{
					return FALSE;
				}
			}


			if(stationary)
			{
				current_step_time = 0;
			}

			if(step_time && !stationary)
			{
				if(current_step_time >= step_time)
				{
					step_rand(src);
					current_step_time = 0
				}
			}

		}

		proc
		{
			Alert(mob/m)
			{
				current_alert_time = 0;
				alert = TRUE;
				alerted_to = m
			}
		}

		Deer
		{
			icon_state = "deer"
			reaction_prob = 95; // 95% chance to choose to run rather than attack.
			var
				grazing = FALSE; // This is pretty obvious.  If they is eating sum graass, leave 'em be!
				grazing_prob = 20; // This is the probability(percentage) that they will stop to eat some grass if they are standing on any.
				obj/last_checked_grass;
				last_graze; //The last time they took a bite.
				graze_time = 20; //The time it takes until they bite again.

			Alert()
			{
				..();
				icon_state = "deer_alerted";
			}

			base_EventCycle()
			{
				if(!alert && !grazing)
				{
					icon_state = "deer";
				}

				if(grazing && !alert)
				{
					icon_state = "deer_graze";
				}

				if(grazing && alert)
				{
					grazing = FALSE;
					icon_state = "deer_alerted";
				}

				if(grazing)
				{
					stationary = TRUE;
				}

				else
				{
					stationary = FALSE;
				}

				..()

				if(grazing)
				{
					last_graze++;

					if(last_graze >= graze_time)
					{
						#ifdef DYNAMIC_ICONS
						last_checked_grass.walked_on += rand(1,3);
						#endif
						last_graze = 0;
						var chance = prob(grazing_prob);
						if(chance)
						{
							grazing = FALSE;
						}
					}
				}

				var/turf/t = locate(src.x,src.y,src.z);

				for(var/v in t)
				{
					if(istype(v, /obj/grass))
					{
						if(v != last_checked_grass) //This little bit just sees if they have already moved to the turf.  We don't want to do prob() checks every tick, only when the mob enters a new grass turf.
						{
							var chance = prob(grazing_prob);
							if(chance)
							{
								grazing = TRUE;
							}
						}

						last_checked_grass = v
					}
				}
			}
		}
	}
	#endif
}